%global distro  OpenCloudOS
%global major   9.0

Summary:        %{distro} release files
Name:           opencloudos-release
Version:        %{major}
Release:        9%{?dist}.1
License:        GPLv2
URL:            https://www.opencloudos.org/
Source0:        OpenCloudOS.repo
Source1:        RPM-GPG-KEY-OpenCloudOS-9

Source200:      EULA
Source201:      LICENSE

Source300:      90-default.preset
Source301:      99-default-disable.preset
Source302:      85-display-manager.preset

Source500:      50-opencloudos.conf

BuildArch:      noarch
Requires:       opencloudos-repos = %{version}-%{release}
Provides:       opencloudos-release = %{version}-%{release}
# Required for a lorax run (to generate install media)
Provides:       opencloudos-release-eula
Provides:       system-release = %{version}-%{release}
Provides:       system-release(releasever) = %{major}

%description
%{distro} release files.


%package -n opencloudos-repos
Summary:        OpenCloudOS package repositories
Requires:       opencloudos-release = %{version}-%{release}

%description -n opencloudos-repos
This package provides the package repository files for OpenCloudOS.


%install
mkdir -p ./docs
cp %{SOURCE201} ./docs

# create /etc/system-release and /etc/opencloudos-release
install -d -m 0755 %{buildroot}%{_sysconfdir}
echo "%{distro} release %{major}" > %{buildroot}%{_sysconfdir}/opencloudos-release
ln -s opencloudos-release %{buildroot}%{_sysconfdir}/system-release


install -d -m 0755 %{buildroot}%{_prefix}/lib
cat > %{buildroot}%{_prefix}/lib/os-release << EOF
NAME="%{distro}"
VERSION="%{major}"
ID="opencloudos"
ID_LIKE="opencloudos"
VERSION_ID="%{major}"
PLATFORM_ID="platform:oc%{major}"
PRETTY_NAME="%{distro} %{major}"
ANSI_COLOR="0;31"
CPE_NAME="cpe:/o:opencloudos:opencloudos:%{major}"
HOME_URL="https://www.opencloudos.org/"
BUG_REPORT_URL="https://bugs.opencloudos.tech/"
EOF

# symlink for /etc/os-release
ln -s ../usr/lib/os-release %{buildroot}%{_sysconfdir}/os-release

# write cpe to /etc/system/release-cpe
echo "cpe:/o:opencloudos:opencloudos:%{major}" > %{buildroot}%{_sysconfdir}/system-release-cpe

# create /etc/issue, /etc/issue.net and /etc/issue.d
echo '\S' > %{buildroot}%{_sysconfdir}/issue
echo 'Kernel \r on an \m' >> %{buildroot}%{_sysconfdir}/issue
cp %{buildroot}%{_sysconfdir}/issue{,.net}
echo >> %{buildroot}%{_sysconfdir}/issue
mkdir -p %{buildroot}%{_sysconfdir}/issue.d

# set up the dist tag macros
mkdir -p %{buildroot}%{_rpmmacrodir}
cat > %{buildroot}%{_rpmmacrodir}/macros.dist << EOF
# dist macros.

%%opencloudos 0
%%ocs %{major}
%%dist .ocs%{major}
EOF

# use unbranded datadir
install -d -m 0755 %{buildroot}%{_datadir}/opencloudos-release

install -p -m 0644 %{SOURCE200} %{buildroot}%{_datadir}/opencloudos-release/

install -d -m 0755 %{buildroot}%{_prefix}/lib/systemd/system-preset/
install -d -m 0755 %{buildroot}%{_prefix}/lib/systemd/user-preset
# copy presets for both system and user
install -p -m 0644 %{SOURCE300} %{SOURCE301} %{SOURCE302} %{buildroot}%{_prefix}/lib/systemd/system-preset/
install -p -m 0644 %{SOURCE300} %{SOURCE301} %{buildroot}%{_prefix}/lib/systemd/user-preset/

mkdir -p %{buildroot}/%{_prefix}/lib/sysctl.d/
install -m 0644 %{SOURCE500} %{buildroot}/%{_prefix}/lib/sysctl.d/

# Create stub yum repos
mkdir %{buildroot}%{_sysconfdir}/yum.repos.d

# copy GPG keys
mkdir -p -m 0755 %{buildroot}/etc/pki/rpm-gpg
install -m 0644 %{SOURCE1} %{buildroot}/etc/pki/rpm-gpg

# copy yum repos
install -d -m 0755 %{buildroot}%{_sysconfdir}/yum.repos.d

install -m 0644 %{SOURCE0} %{buildroot}%{_sysconfdir}/yum.repos.d/

# dnf variables
install -d -m 0755 %{buildroot}%{_sysconfdir}/dnf/vars
echo "%{major}" > %{buildroot}%{_sysconfdir}/dnf/vars/releasever


%files
%license docs/LICENSE
%{_sysconfdir}/opencloudos-release
%{_sysconfdir}/system-release
%config(noreplace) %{_sysconfdir}/os-release
%config %{_sysconfdir}/system-release-cpe
%config(noreplace) %{_sysconfdir}/issue
%config(noreplace) %{_sysconfdir}/issue.net
%dir %{_sysconfdir}/issue.d
%dir %{_sysconfdir}/yum.repos.d
%{_rpmmacrodir}/macros.dist
%{_datadir}/opencloudos-release
%{_prefix}/lib/os-release
%{_prefix}/lib/sysctl.d/50-opencloudos.conf
%{_prefix}/lib/systemd/system-preset/*
%{_prefix}/lib/systemd/user-preset/*


%files -n opencloudos-repos
%config(noreplace) %{_sysconfdir}/dnf/vars/releasever
%config(noreplace) %{_sysconfdir}/yum.repos.d/OpenCloudOS.repo
/etc/pki/rpm-gpg/


%changelog
* Sat Jan 06 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 9.0-9.1
- Rebuild

* Fri Jan 05 2024 Xin Cheng <denisecheng@tencent.com> - 9.0-9
- Enable pipewire for audio use

* Fri Oct 13 2023 Xin Cheng <denisecheng@tencent.com> - 9.0-8
- Update source and debug repo path

* Thu Sep 14 2023 Xin Cheng <denisecheng@tencent.com> - 9.0-7
- Enable gdm.service by default

* Thu Jun 15 2023 Xin Cheng <denisecheng@tencent.com> - 9.0-6
- Revert "Disable systemd-resolved by default"

* Wed Jun 14 2023 Xin Cheng <denisecheng@tencent.com> - 9.0-5
- enable getty@.service instead of getty@tty1.service.

* Thu Apr 20 2023 cunshunxia <cunshunxia@tencent.com> - 9.0-4
- Disable systemd-resolved by default.

* Fri Apr 14 2023 Xin Cheng <denisecheng@tencent.com> - 9.0-3
- Update name of debug repo

* Thu Mar 16 2023 Xin Cheng <denisecheng@tencent.com> - 9.0-2
- Update version to 9.0
- Update LICENSE

* Mon Feb 06 2023 Xun Zhong <victorzhong@tencent.com> - 9-1
- rebrand for oc9

* Tue Dec 27 2022 Yi Lin <nilusyi@tencent.com> - 2301-6
- add enabled key in repo file.

* Fri Dec 23 2022 Yi Lin <nilusyi@tencent.com> - 2301-5
- add noreplace attr in repo file.

* Thu Dec 22 2022 Yi Lin <nilusyi@tencent.com> - 2301-4
- change repo to releasever and basearch.

* Thu Dec 22 2022 Yi Lin <nilusyi@tencent.com> - 2301-3
- mv yum repo into repos pkg.

* Thu Dec 22 2022 Yi Lin <nilusyi@tencent.com> - 2301-2
- add yum repo.

* Wed Dec 21 2022 Yi Lin <nilusyi@tencent.com> - 2301-1
- define major version to 2301.

* Wed Dec 21 2022 rockerzhu <rockerzhu@tencent.com> - 1.0-6
- disable oomd service.

* Wed Dec 21 2022 rockerzhu <rockerzhu@tencent.com> - 1.0-5
- add default startup services

* Wed Dec 14 2022 rockerzhu <rockerzhu@tencent.com> - 1.0-4
- Initial default startup services

* Wed Oct 26 2022 rockerzhu <rockerzhu@tencent.com> - 1.0-3
- Add preset for default disable

* Thu Oct 20 2022 Wang Guodong <gordonwwang@tencent.com> - 1.0-2
- Rename the macro %oc to %ocs

* Thu Aug 11 2022 Yi Lin <nilusyi@tencent.com> - 1.0-1
- Initial setup for OpenCloudOS Stream
